@echo off
cls

echo.
echo *****************************************************
echo https://brutaldev.com
echo Maximum lossless image compression and optimization.
echo *****************************************************
echo.

echo DOWNLOADING TOOLS...

if not exist gifsicle.exe (
  echo.
  echo Gifsicle not found, downloading...
  powershell -NonInteractive -Command "(new-object System.Net.WebClient).DownloadFile('https://eternallybored.org/misc/gifsicle/gifsicle-1.87-win32.zip', 'gifsicle.zip')"
  7za.exe x -y gifsicle.zip gifsicle-1.87\gifsicle.exe
  move gifsicle-1.87\gifsicle.exe gifsicle.exe
  rd /q gifsicle-1.87
)

rem pause

if not exist jpegoptim.exe (
  echo.
  echo JpegOptim not found, downloading...
  powershell -NonInteractive -Command "(new-object System.Net.WebClient).DownloadFile('http://pornel.net/jpegoptim.zip', 'jpegoptim.zip')"
  7za.exe x -y jpegoptim.zip jpegoptim.exe
)

rem pause

if not exist jpegtran.exe (
  echo.
  echo JpegTran not found, downloading...
  powershell -NonInteractive -Command "(new-object System.Net.WebClient).DownloadFile('http://jpegclub.org/jpegtran/jpegtran.exe', 'jpegtran.exe')"
)

rem pause

if not exist optipng.exe (
  echo.
  echo OptiPng not found, downloading...
  powershell -NonInteractive -Command "(new-object System.Net.WebClient).DownloadFile('http://downloads.sourceforge.net/project/optipng/OptiPNG/optipng-0.7.4/optipng-0.7.4-win32.zip', 'optipng.zip')"
  7za.exe x -y optipng.zip optipng-0.7.4-win32\optipng.exe
  copy /y optipng-0.7.4-win32\optipng.exe optipng.exe
  rd /s /q optipng-0.7.4-win32
)

rem pause

if not exist pngcrush.exe (
  echo.
  echo PngCrush not found, downloading...
  powershell -NonInteractive -Command "(new-object System.Net.WebClient).DownloadFile('http://downloads.sourceforge.net/project/pmt/pngcrush-executables/1.7.86/pngcrush_1_7_86_w32.exe', 'pngcrush.exe')"
)

rem pause

if not exist pngout.exe (
  echo.
  echo PngOut not found, downloading...
  powershell -NonInteractive -Command "(new-object System.Net.WebClient).DownloadFile('http://advsys.net/ken/util/pngout.exe', 'pngout.exe')"
  rem http://download1us.softpedia.com/dl/5054c00634f720e9798526ac56413b5d/5086a53b/100119704/software/multimedia/graphic/pngout.exe
)

rem pause

if not exist deflopt.exe (
  echo.
  echo DeflOpt not found, downloading...
  powershell -NonInteractive -Command "(new-object System.Net.WebClient).DownloadFile('http://givemerub.com/n/13895515/DeflOpt.exe', 'deflopt.exe')"
)

echo.
echo Cleaning up downloaded files...
del /q *.zip
del /q *.7z

echo.
echo Downloads complete.
pause