@echo off
cls

echo.
echo *****************************************************
echo http://brutaldev.com
echo Maximum lossless image compression and optimization.
echo *****************************************************
echo.

set _tools=%~dp0
set /p _working="Image directory to optimize: "

pushd %_tools%

cd "%_working%"

echo.
echo COMPRESSING IMAGES...
echo.

echo.
echo Optimize using gifsicle (GIF)...
for /r %%a in (*.gif) do %_tools%gifsicle.exe -O2 "%%a" -o "%%a"

echo.
echo Optimize using jpegoptim and jpegtran (JPG)...
for /r %%a in (*.jpg) do (
  %_tools%jpegoptim.exe -o --strip-all "%%a"
  %_tools%jpegtran.exe -optimize "%%a" "%%a"
)

echo. 
echo Optimize using optipng, pngcrush, pngout and deflopt (PNG)...
for /r %%a in (*.png) do (
  %_tools%optipng.exe -o7 "%%a"
  %_tools%pngcrush.exe -brute -reduce "%%a" "%%a".crush
  copy /y "%%a".crush "%%a"
  del "%%a".crush  
  %_tools%pngout.exe /y "%%a" "%%a"
  rem %_tools%deflopt.exe "%%a"
)

echo.
pause

popd
set _tools=
set _working=